<template>
  <div class="row">
    <div class="col-md-12">
      <transition name="fade">
        <div v-if="paginationData">
          <b-pagination
            v-model="currentPage"
            :total-rows="paginationData.total"
            :per-page="paginationData.per_page"
            @change="getTopups"
          ></b-pagination>

          <table class="table table-active mb-3">
            <thead class="table-dark">
              <tr>
                <th scope="col"></th>
                <th scope="col">{{ $t("currency") }}</th>
                <th scope="col">{{ $t("fiat_amount") }}</th>
                <th scope="col">{{ $t("status") }}</th>
              </tr>
            </thead>
            <tbody>
              <tr v-for="topup in topups" :key="topup.id">
                <th scope="row" class="align-middle">
                  <router-link
                    :to="{ name: 'panel.topups.get', params: { id: topup.id } }"
                    class="btn btn-outline-info btn-sm"
                  >
                    {{ $t("view") }}
                  </router-link>
                </th>
                <td class="align-middle">
                  <cryptoicon :symbol="topup.currency.code" size="26" />
                </td>
                <td class="align-middle">
                  <h6>
                    <span class="badge badge-dark">
                      {{
                        topup.fiat_amount
                          .replace(".", ",")
                          .replace(/\B(?=(\d{3})+(?!\d))/g, ".")
                      }}
                      EUR</span
                    >
                  </h6>
                </td>
                <td class="align-middle">
                  <h6>
                    <span
                      v-if="topup.status == 'confirmed'"
                      class="badge badge-success"
                      >{{ $t("status_success") }}</span
                    >
                    <span
                      v-if="topup.status == 'paid'"
                      class="badge badge-warning"
                      >{{ $t("status_paid") }}</span
                    >
                    <span
                      v-if="topup.status == 'pending'"
                      class="badge badge-warning"
                      >{{ $t("status_pending") }}</span
                    >
                  </h6>
                </td>
              </tr>
            </tbody>
          </table>

          <b-pagination
            v-model="currentPage"
            :total-rows="paginationData.total"
            :per-page="paginationData.per_page"
            @change="getTopups"
          ></b-pagination>

          <card :title="$t('topup')">
            <form @submit.prevent="create" @keydown="form.onKeydown($event)">
              <!-- EUR Amount -->
              <div class="form-group row">
                <label class="col-md-3 col-form-label text-md-right">{{
                  $t("fiat_amount")
                }}</label>
                <div class="col-md-7">
                  <input
                    v-model="form.fiat_amount"
                    :class="{ 'is-invalid': form.errors.has('fiat_amount') }"
                    class="form-control"
                    type="text"
                    name="fiat_amount"
                  />
                  <has-error :form="form" field="fiat_amount" />
                </div>
              </div>
              <div class="form-group row">
                <label class="col-md-3 col-form-label text-md-right">{{
                  $t("currency")
                }}</label>
                <div class="col-md-7">
                  <select
                    class="form-control"
                    name="currency"
                    v-model="form.currency"
                  >
                    <option
                      v-for="currency in currencies"
                      v-bind:value="currency.code"
                    >
                      {{ currency.name }}
                    </option>
                  </select>
                  <has-error :form="form" field="currency" />
                </div>
              </div>

              <!-- Submit Button -->
              <div class="form-group row">
                <div class="col-md-9 ml-md-auto">
                  <v-button :loading="form.busy" type="success">
                    {{ $t("create") }}
                  </v-button>
                </div>
              </div>
            </form>
          </card>
        </div>
      </transition>
    </div>
  </div>
</template>

<script>
import Form from "vform";
import { mapGetters } from "vuex";
import axios from "axios";

export default {
  scrollToTop: false,

  metaInfo() {
    return { title: this.$t("panel") };
  },

  data: () => ({
    form: new Form({
      fiat_amount: "",
      currency: "BTC",
    }),
    paginationData: null,
    currentPage: 1,
  }),

  created() {
    this.getTopups();
    this.$store.cache.dispatch("currency/fetchCurrencies");
  },

  computed: {
    ...mapGetters({
      user: "auth/user",
      currencies: "currency/currencies",
    }),
    topups() {
      return this.paginationData.data;
    },
  },

  methods: {
    async getTopups(page = 1) {
      const { data } = await axios.get(route('shop.topups.index') + '?page=' + page);
      if (data) {
        this.paginationData = data;
      }
    },

    async create() {
      var topup = (await this.form.post(route('shop.topups.create'))).data;
      if (topup) {
        this.$router.push({
          name: "panel.topups.get",
          params: { id: topup.id },
        });
      }
    },
  },
};
</script>
